import 'dart:typed_data';

import 'package:diplomaticquarterapp/analytics/google-analytics.dart';
import 'package:diplomaticquarterapp/config/shared_pref_kay.dart';
import 'package:diplomaticquarterapp/locator.dart';
import 'package:diplomaticquarterapp/models/Appointments/AppoimentAllHistoryResultList.dart';
import 'package:diplomaticquarterapp/models/Appointments/DoctorListResponse.dart';
import 'package:diplomaticquarterapp/models/Appointments/PatientShareResposne.dart';
import 'package:diplomaticquarterapp/models/Authentication/authenticated_user.dart';
import 'package:diplomaticquarterapp/models/header_model.dart';
import 'package:diplomaticquarterapp/routes.dart';
import 'package:diplomaticquarterapp/services/appointment_services/GetDoctorsList.dart';
import 'package:diplomaticquarterapp/theme/colors.dart';
import 'package:diplomaticquarterapp/uitl/app_shared_preferences.dart';
import 'package:diplomaticquarterapp/uitl/app_toast.dart';
import 'package:diplomaticquarterapp/uitl/date_uitl.dart';
import 'package:diplomaticquarterapp/uitl/gif_loader_dialog_utils.dart';
import 'package:diplomaticquarterapp/uitl/translations_delegate_base.dart';
import 'package:diplomaticquarterapp/widgets/buttons/custom_text_button.dart';
import 'package:diplomaticquarterapp/widgets/dialogs/confirm_dialog.dart';
import 'package:diplomaticquarterapp/widgets/new_design/doctor_header.dart';
import 'package:diplomaticquarterapp/widgets/nfc/nfc_reader_sheet.dart';
import 'package:diplomaticquarterapp/widgets/others/app_scaffold_widget.dart';
import 'package:flutter/material.dart';
import 'package:flutter_nfc_kit/flutter_nfc_kit.dart';
import 'package:flutter_svg/flutter_svg.dart';

class QRCode extends StatefulWidget {
  PatientShareResponse patientShareResponse;
  AppoitmentAllHistoryResultList appointment;
  String appoQR;
  AuthenticatedUser authUser;
  AppSharedPreferences sharedPref = AppSharedPreferences();

  QRCode({@required this.patientShareResponse, @required this.appoQR, @required this.appointment});

  @override
  _QRCodeState createState() => _QRCodeState();
}

class _QRCodeState extends State<QRCode> {
  Uint8List _bytes;
  bool _supportsNFC = false;
  BuildContext _context;

  @override
  void initState() {
    // TODO: implement initState

    // _bytes = base64.decode(widget.appoQR.split(',').last);
    widget.authUser = new AuthenticatedUser();

    FlutterNfcKit.nfcAvailability.then((value) {
      _supportsNFC = (value == NFCAvailability.available);
    });

    WidgetsBinding.instance.addPostFrameCallback((timeStamp) {
      startNFCScan();
    });

    super.initState();
  }

  startNFCScan() {
    Future.delayed(const Duration(milliseconds: 500), () {
      showNfcReader(context, onNcfScan: (String nfcId) {
        Future.delayed(const Duration(milliseconds: 100), () {
          sendNfcCheckInRequest(nfcId);
          locator<GAnalytics>().todoList.to_do_list_nfc(widget.appointment);
        });
      }, onCancel: () {
        // Navigator.of(context).pop();
        locator<GAnalytics>().todoList.to_do_list_nfc_cancel(widget.appointment);
      });
    });
  }

  @override
  Widget build(BuildContext context) {
    _context = context;
    return AppScaffold(
      appBarTitle: TranslationBase.of(context).onlineCheckIn,
      isShowAppBar: true,
      showNewAppBar: true,
      showNewAppBarTitle: true,
      body: SingleChildScrollView(
        child: Column(
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            DoctorHeader(
              headerModel: HeaderModel(
                widget.appointment.doctorTitle + " " + widget.appointment.doctorNameObj,
                widget.appointment.doctorID,
                widget.appointment.doctorImageURL,
                widget.appointment.doctorSpeciality,
                "",
                widget.appointment.projectName,
                DateUtil.convertStringToDate(widget.appointment.appointmentDate),
                widget.appointment.isLiveCareAppointment
                    ? DateUtil.convertStringToDate(widget.appointment.appointmentDate).toString().split(" ")[1].substring(0, 5)
                    : widget.appointment.startTime.substring(0, 5),
                null,
                widget.appointment.doctorRate,
                widget.appointment.actualDoctorRate,
                widget.appointment.noOfPatientsRate,
                "",
              ),
              isShowName: true,
              isNeedToShowButton: false,
              buttonTitle: '',
              onTap: () {},
              onRatingAndReviewTap: () {},
            ),
            InkWell(
              child: Container(
                margin: EdgeInsets.only(top: 30.0),
                padding: EdgeInsets.all(8),
                child: SvgPicture.asset(
                  "assets/images/nfc/contactless.svg",
                  width: 80.0,
                  height: 80.0,
                ),
              ),
              onTap: () {
                showNfcReader(context, onNcfScan: (String nfcId) {
                  Future.delayed(const Duration(milliseconds: 100), () {
                    sendNfcCheckInRequest(nfcId);
                    locator<GAnalytics>().todoList.to_do_list_nfc(widget.appointment);
                  });
                }, onCancel: () {
                  // Navigator.of(context).pop();
                  locator<GAnalytics>().todoList.to_do_list_nfc_cancel(widget.appointment);
                });
              },
            ),
            Row(
              children: <Widget>[
                Expanded(
                  child: Container(
                    width: double.infinity,
                    margin: EdgeInsets.only(top: 15.0, bottom: 10.0, left: 20.0, right: 20.0),
                    child: Text(TranslationBase.of(context).scanQRHospital,
                        style: TextStyle(
                          fontSize: 20,
                          fontWeight: FontWeight.w600,
                          letterSpacing: -0.48,
                        )),
                  ),
                ),
              ],
            ),
          ],
        ),
      ),
      bottomSheet: Container(
        color: CustomColors.appBackgroudGreyColor,
        padding: EdgeInsets.all(21),
        // height: 45.0,
        child: Row(
          children: [
            Expanded(
              flex: 1,
              child: ButtonTheme(
                shape: RoundedRectangleBorder(
                  borderRadius: BorderRadius.circular(10.0),
                ),
                height: 45.0,
                child: CustomTextButton(
                  backgroundColor: CustomColors.green,
                  elevation: 0,
                  onPressed: () {
                    startNFCScan();
                  },
                  child: Text(TranslationBase.of(context).scanNFC,
                      style: TextStyle(
                        fontSize: 18.0,
                        color: Colors.white,
                      )),
                ),
              ),
            ),
          ],
        ),
      ),
    );
  }

  sendEmail() async {
    DoctorsListService service = new DoctorsListService();

    if (await widget.sharedPref.getObject(USER_PROFILE) != null) {
      var data = AuthenticatedUser.fromJson(await widget.sharedPref.getObject(USER_PROFILE));
      setState(() {
        widget.authUser = data;
      });
    }

    ConfirmDialog dialog = new ConfirmDialog(
        context: context,
        confirmMessage: "Send a copy of this QR to the email " + widget.authUser.emailAddress + "?",
        okText: TranslationBase.of(context).confirm,
        cancelText: TranslationBase.of(context).cancel_nocaps,
        okFunction: () {
          GifLoaderDialogUtils.showMyDialog(context);
          service
              .sendAppointmentQREmail(widget.authUser.emailAddress, widget.patientShareResponse.appointmentDate, widget.patientShareResponse.appointmentNo.toString(),
                  widget.patientShareResponse.doctorNameObj, widget.patientShareResponse.projectName, widget.appoQR, getDoctorSpeciality(widget.patientShareResponse.doctorSpeciality), context)
              .then((res) {
            GifLoaderDialogUtils.hideDialog(context);
            ConfirmDialog.closeAlertDialog(context);
          }).catchError((err) {
            ConfirmDialog.closeAlertDialog(context);
            GifLoaderDialogUtils.hideDialog(context);
            AppToast.showErrorToast(message: err);
            print(err);
          });
        },
        cancelFunction: () => {});
    dialog.showAlertDialog(context);
  }

  Future navigateToHome(context) async {
    Navigator.of(context).pushNamed(HOME);
  }

  getPatientShare(context, String appointmentNo, int clinicID, int projectID, DoctorList docObject) {}

  String getDate(String appoDate) {
    var appoDateFormatted = "";

    var dateObj = DateUtil.convertStringToDate(appoDate);

    setState(() {
      appoDateFormatted = DateUtil.getWeekDay(dateObj.weekday) +
          ", " +
          dateObj.day.toString() +
          " " +
          DateUtil.getMonth(dateObj.month) +
          " " +
          dateObj.year.toString() +
          ", " +
          dateObj.hour.toString() +
          ":" +
          dateObj.minute.toString() +
          ":00";
    });

    return appoDateFormatted;
  }

  String getDoctorSpeciality(List<String> docSpecial) {
    String docSpeciality = "";
    if (docSpecial != null && docSpecial.length != 0) {
      docSpecial.forEach((v) {
        docSpeciality = docSpeciality + v + "\n";
      });
    }
    return docSpeciality;
  }

  sendNfcCheckInRequest(String nfcId) {
    GifLoaderDialogUtils.showMyDialog(context);

    DoctorsListService service = new DoctorsListService();

    service.sendCheckinNfcRequest(widget.patientShareResponse.appointmentNo, nfcId, widget.patientShareResponse.projectID, context).then((res) {
      print(res);

      GifLoaderDialogUtils.hideDialog(context);
      _showMyDialog(res["SuccessMsg"], this.context);
    }).catchError((err) {
      GifLoaderDialogUtils.hideDialog(context);
      print(err);
      _showMyDialog(err, this.context);
    });
  }

  Future<void> _showMyDialog(String message, BuildContext context) async {
    return showDialog<void>(
      context: context,
      barrierDismissible: true, // user must tap button!
      builder: (BuildContext context) {
        return AlertDialog(
          title: const Text('Alert'),
          content: SingleChildScrollView(
            child: ListBody(
              children: <Widget>[
                Text(message),
              ],
            ),
          ),
          actions: <Widget>[
            TextButton(
              child: const Text('OK'),
              onPressed: () {
                Navigator.of(context).pop();
              },
            ),
          ],
        );
      },
    );
  }
}
